/* (bad) Clone of Intellivision Snafu  - gauze@dropdead.org */
/* imagine GPL stuff here   October 2001 */

#include <stdio.h>
#include <unistd.h>
#include <ncurses.h>
#include <strings.h>

#define PLAY1 '#'
#define PLAY2 '%'
#define UP_HEAD '^'
#define DOWN_HEAD 'v'
#define LEFT_HEAD '<'
#define RIGHT_HEAD '>'
#define BORDER ACS_BLOCK
#define SPACE ' '
#define CRASH '*'

int field[24][80];

struct Player 
{
	signed int score;
	char direction;
	bool scored;
	signed int posX;
	signed int posY;

} Player1, Player2;


// function headers
void crash(void);
int score(int x);
void start(void);
void action(void);
void draw(void);
void get_keys(void);
void help(void);
void ready(void);



int main(int argc, char *argv[]) 
{
	int i;
	
      	/* ncurses crap*/
	WINDOW *mw;
	mw = initscr(); 
	cbreak(); 
	noecho();
	/* keypad(mw, TRUE); */
//A	halfdelay(1);
	nodelay( mw , TRUE );
	if (argc > 1)
		if ( (strcmp(argv[1],"--help") || strcmp(argv[1],"-h")) )
			help();
	
	if (has_colors())
	{
	start_color();
	init_pair(COLOR_BLACK, COLOR_BLACK, COLOR_BLACK);
        init_pair(COLOR_GREEN, COLOR_GREEN, COLOR_BLACK);
        init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
        init_pair(COLOR_CYAN, COLOR_CYAN, COLOR_BLACK);
        init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);
        init_pair(COLOR_MAGENTA, COLOR_MAGENTA, COLOR_BLACK);
        init_pair(COLOR_BLUE, COLOR_BLUE, COLOR_BLACK);
        init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);
	}
	// end of ncurses init

	while ( Player1.score < 10 && Player2.score < 10 ) 
	{
		start();
		clear();
		ready();

		while ( !(Player1.scored || Player2.scored)  ) 
		{
			action();
			draw();
			get_keys();
			flushinp();
		}
		crash();

		if ( Player1.scored == TRUE )
			Player1.score++;
		if ( Player2.scored == TRUE )
			Player2.score++;

		draw();
		
	}

	/* Display Winner ending thing */
	attron(COLOR_PAIR(4));
	for ( i = 30; i < 46 ; i++ )
	{
		mvprintw(11,i, "%c" , ACS_BOARD);
		mvprintw(13,i, "%c" , ACS_BOARD);
	
	}
	if ( Player1.score > Player2.score )
		mvprintw(12,30,"%cPlayer 1 wins!%c", ACS_BOARD, ACS_BOARD);
	else if ( Player1.score < Player2.score )
		mvprintw(12,30,"%cPlayer 2 wins!%c", ACS_BOARD, ACS_BOARD);
	else if ( Player1.score == Player2.score )
		mvprintw(12,30,"%c It's a Tie!! %c", ACS_BOARD, ACS_BOARD);

	attroff(COLOR_PAIR(4));
	refresh();

	endwin();

	return(0);
}

void ready(void) 
{
	int i, j;

	for ( i = 3 ; i > 0 ; i-- )
	{
		for ( j = 30; j < 40 ; j++)
		{
			mvprintw(11, j, "%c", ACS_BOARD);
			mvprintw(13, j, "%c", ACS_BOARD);
		}
	 	mvprintw(12,30,"%cReady? %d%c", ACS_BOARD, i,ACS_BOARD);
		mvprintw(24,0, "Player 1:  %d                                                      Player 2:  %d", Player1.score , Player2.score );
		refresh();
		sleep(1);
	}
	flushinp();
}

void start(void)
{
	
	int i, j;
        Player1.posY = 12; 
	Player1.posX = 25;  
	Player2.posY = 12; 
	Player2.posX = 54;
	Player1.direction = 'L';
	Player2.direction = 'R';
	Player1.scored = FALSE;
	Player2.scored = FALSE;
	
	for ( i = 0; i < 80 ; i++ )
	{
		field[0][i] = 1; // 1 = '|'
		field[23][i] = 1; // 1 = '|'
	}
	
	for ( i = 1; i < 23 ; i++ )
	{
		field[i][0] = 1;
		field[i][79] = 1;
		for ( j = 1 ; j < 79 ; j++ )
			field[i][j] = 0; // 0 = ' '
	}
}

void action(void)
{

	switch (Player1.direction) 
	{
		case 'R': Player1.posX++;
		break;
		case 'L': Player1.posX--;
		break;
		case 'U': Player1.posY--;
		break;
		case 'D': Player1.posY++;
		break;
	}

	switch (Player2.direction) 
	{
		case 'R': Player2.posX++;
		break;
		case 'L': Player2.posX--;
		break;
		case 'U': Player2.posY--;
		break;
		case 'D': Player2.posY++;
		break;
	}
	/* add the trails to the fucking field array thing */

	if ( Player1.posY >= 23 || Player1.posY <= 0 || 
	     Player1.posX >= 80 || Player1.posX <= 0 ||
	     field[Player1.posY][Player1.posX] != 0 )
	{
		Player2.scored = TRUE;
		Player1.direction = 'C';
	} else 
		field[Player1.posY][Player1.posX] = 3;
	
	
	if ( Player2.posY >= 23 || Player2.posY <= 0 || 
  	            Player2.posX >= 80 || Player2.posX <= 0 ||
	            field[Player2.posY][Player2.posX] != 0 )
	{
		Player1.scored = TRUE;
		Player2.direction = 'C';
	} else 
		field[Player2.posY][Player2.posX] = 4;
	
	usleep(200000);
}


void crash(void)
{
	int i;
	attron(COLOR_PAIR(3));
	for ( i = 33; i < 41 ; i++ )
	{
		mvprintw( 11, i, "%c" , ACS_BOARD );
		mvprintw( 13, i, "%c" , ACS_BOARD );
	}
	mvprintw(12,33,"%cCRASH!%c", ACS_BOARD, ACS_BOARD); 
	beep();
	attroff(COLOR_PAIR(3));
	refresh();
	sleep(1);
}

void draw(void)
{
	int y, x, color;
	char foo, CUR_HEAD1, CUR_HEAD2;
	
	
	switch (Player1.direction)
	{
		case 'C': CUR_HEAD1 = CRASH;
			  break;
		case 'R': CUR_HEAD1 = RIGHT_HEAD;
			  break;
		case 'L': CUR_HEAD1 = LEFT_HEAD;
			  break;
		case 'U': CUR_HEAD1 = UP_HEAD;
			  break;
		case 'D': CUR_HEAD1 = DOWN_HEAD;
		default : break;
	}
	switch (Player2.direction)
	{
		case 'C': CUR_HEAD2 = CRASH;
			  break;
		case 'R': CUR_HEAD2 = RIGHT_HEAD;
			  break;
		case 'L': CUR_HEAD2 = LEFT_HEAD;
			  break;
		case 'U': CUR_HEAD2 = UP_HEAD;
			  break;
		case 'D': CUR_HEAD2 = DOWN_HEAD;
		default : break;
	}
	
	for ( y=0; y <= 23 ; y++)
		for ( x = 0; x < 80 ; x++)
		{
			switch (field[y][x])
			{	
				case 0: foo = SPACE;
					break;
				case 1: foo = BORDER;
					color = 6;
					break;
				case 2: foo = CRASH;
					break;
				case 3: foo = PLAY1;
					color = 5;
					break;
				case 4: foo = PLAY2;
					color = 7;
					break;
				default: foo = SPACE;
					break;
			}	
			attron(COLOR_PAIR(color));
			mvprintw(y,x,"%c", foo );
			attroff(COLOR_PAIR(color));
		}
	
	attron(COLOR_PAIR(3));
	mvprintw(Player1.posY,Player1.posX, "%c" , CUR_HEAD1);
	mvprintw(Player2.posY,Player2.posX, "%c" , CUR_HEAD2);
	attroff(COLOR_PAIR(3));
  	attron(COLOR_PAIR(2));
	mvprintw(24,0, "Player 1:  %d                                                      Player 2:  %d", 
		        Player1.score , Player2.score );
  	attroff(COLOR_PAIR(2));
	
	refresh();


}

void get_keys(void)
{
	chtype keyring;
	if ( (int)(keyring = getch()) != ERR )
	{
				
		if (keyring == 's') 
			if ( Player1.direction != 'R' )
				Player1.direction = 'L';
		if (keyring == 'f') 
			if ( Player1.direction != 'L' )
				Player1.direction = 'R';
		if (keyring == 'e') 
			if ( Player1.direction != 'D' )
				Player1.direction = 'U';
		if (keyring == 'd') 
			if ( Player1.direction != 'U' )
				Player1.direction = 'D';

		if (keyring == 'h')
			if ( Player2.direction != 'R' )
				Player2.direction = 'L';
		if (keyring == 'l') 
			if ( Player2.direction != 'L' )
				Player2.direction = 'R';
		if (keyring == 'k') 
			if ( Player2.direction != 'D' )
				Player2.direction = 'U';
		if (keyring == 'j') 
			if ( Player2.direction != 'U' )
				Player2.direction = 'D';
		
	}
}

void help(void)
{
	endwin();
	printf("\n SNAFU\n 2001 - GNU GPL Copyleft\n"); 
	printf("Player 1 controls: s=left f=right e=up d=down\n");
	printf("Player 2 controls: h=left l=right k=up j=down\n");
	exit(0);
}
